package manov3;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.net.*;
import java.util.EventListener;
import java.util.EventObject;
import java.util.Locale;
import javax.swing.*;
 
public class MyIcon3 extends JComponent{
    private double gra=0,xgra,inc,dif;
    private ImageIcon icon;
    private int icoW,icoH,xC,yC,dir=0,flg=0;
    private String val="";
    private double icoWd,icoHd,nwx,nwy,gr,grc;

    public MyIcon3(){        
        icon = createImageIcon("/image/mano02.png");
        icoW = icon.getIconWidth();
        icoH = icon.getIconHeight();
        icoWd=(double)icoW;
        icoHd=(double)icoH;
        setSize(icoW,icoH);
        setPreferredSize(new Dimension(icoW,icoH));
             
        addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent e) {
                if(flg==1){
                    modAng(e.getPoint());
                    fireValChangedEvent(val);
                    repaint();
                }
            }
        });        
        addMouseMotionListener(new MouseMotionAdapter() {
            @Override
            public void mouseDragged(MouseEvent e) {
                if(flg==2){
                    xgra=gra;
                    modAng(e.getPoint());
                    fireValChangedEvent(val);
                    repaint();
                }
            }
        }); 
               
    }
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d =(Graphics2D)g;        
        xC =icoW/2;
        yC =icoH/2;
        g2d.translate(xC,yC); 
        g2d.rotate(Math.toRadians(gra)); 
        g2d.translate(-xC,-yC);
        icon.paintIcon(this, g2d, 0, 0);
    }
    //Metodi Pubblici
    public int getWp(){        
        return(icoW);
    }
    public int getHp(){        
        return(icoH);
    }
    public String getVal(){
        val=String.format(new Locale("en"),"%1$.2f",gra);
        return(val);
    }
    public void setInc(double ic){
        inc=ic;  
    } 
    public void setFlg(int fg){
        flg=fg;  
    }   
    public void chgDir(){
        if(dir==1)dir=0; else dir=1;  
    }
    //End Metodi Pubblici
    
    //controllo della posizione
    public void varia(){        
        if(dir==0){          
            gra=gra+inc;
            if(gra>360){
               gra=gra-360;                    
            }                                  
        }else{
            if(gra==0){
                gra=360-inc;
            }else{
                gra=gra-inc;
                if(gra<0){
                gra=gra+360;                    
                } 
            }
        }
        repaint();                 
    }        
    private void modAng(Point pt){
        //trasforma in coordinate rispetto al centro con origine est
        nwx=pt.x-(icoWd/2);
        nwy=(icoHd/2)-pt.y;
        //ricava angolo in radianti
        gr=Math.atan2(nwy, nwx);        
        //trasforma angolo da radianti in gradi centesimali
        grc=Math.toDegrees(gr);
        //Trasforma origine dell'angolo da est a nord
        dif=450-grc;
        if(dif>360)gra=dif-360; else gra=dif;
        //if(flg==2)gra=-xgra;
        val=String.format(new Locale("en"),"%1$.2f",gra);
       
    }
    private void fireValChangedEvent(String st){
         ValEvent event = new ValEvent(this,st);
         Object[] listenersArray = listenerList.getListenerList();
         for(int i = listenersArray.length - 2; i >= 0; i -= 2){
             if(listenersArray[i] == ValEventListener.class){
                 ((ValEventListener)listenersArray[i+1]).valChanged(event);
             }
         }
    }
    public void addValListener(ValEventListener listener){
        listenerList.add(ValEventListener.class, listener);
    }
    private ImageIcon createImageIcon(String path) {
        URL imgURL = getClass().getResource(path);
        if (imgURL != null) {
           return new ImageIcon(imgURL);
        } else {
            System.err.println("Non è possibile trovare il file: " + path);
            return null;
        }
    }
}
class ValEvent extends EventObject{
     private String str;
     public ValEvent(Object source,String st){
        super(source);
        str=st;
      }
      public String val(){
        return(str);
      }
 } 
interface ValEventListener extends EventListener{
    public void valChanged(ValEvent ev);   
}       